Subject: Re: relationship between ingress policer and netfilter hooks?

From: Patrick McHardy <[email-masked]>
Date: Wed, 03 Jun 2009 09:18:55 +0200

Chris Friesen wrote:
> Patrick McHardy wrote:
>> Chris Friesen wrote:
>>
>>> Hi all,
>>>
>>> Can someone tell me where the hook is for incoming packets to be sent
>>> through the ingress policer?
>>>
>>> In particular, I'm trying to find out how the ingress traffic shaping
>>> hook relates to the various netfilter hooks so that I can set them up to
>>> behave nicely together.
> 
>> They're not related at all. The ingress qdisc is hooked at
>> net/dev/core.c:handle_ing().
> 
> Thanks.  Based on that the shaping is done before any of the netfilter
> hooks, which is what I was trying to figure out.

Correct.

> On a related note...the deliver_skb() call right before the call to
> handle_ing()--is that to allow packet sockets to receive everything that
> arrives on the wire even if some of it may be dropped later?

Yes, its the final delivery for ptype_all handlers.